var Native = cc.Class({
    init: function () {
        console.log('native', 'init');
        this.listeners = [];
        this.registered = false;
        this.register();
        return this;
    },

    register: function register() {
        console.log('native', 'register1');
        if (!this.registered) {
            this.registered = true;
            console.log('native', 'register2');

            var self = this;

            cc.director.notificationJsGame = function (eventName, data) {
                console.log('notificationJsGame', eventName, data);
                if (eventName === 'COCOS_GAME_START') {
                    var _data = JSON.parse(decodeURIComponent(data));
                    console.log('gamePath:', _data.gamePath, 'onlineEnv:', _data.onlineEnv,
                                'cs:', _data.cs, 'ss:', _data.ss, 'ac:', _data.ac,
                                'uid:', _data.uid, 'nickname:', _data.nickname,
                                'headPic:', _data.headPic, 'roomID:', _data.roomID,
                                'gameID:', _data.gameID);
                    cc._gamePath = _data.gamePath;
                    cc._onlineEnv = _data.onlineEnv;
                    cc._cs = _data.cs;
                    cc._ss = _data.ss;
                    cc._ac = decodeURIComponent(_data.ac) || '';
                    cc._uid = _data.uid;
                    cc._nickname = _data.nickname;
                    cc._headPic = _data.headPic;
                    cc._roomID = _data.roomID;
                    cc._gameID = _data.gameID;

                    cc.director.startGame(_data.gamePath);
                }
            }
        }
    },

    unregister: function () {
        cc.director.notificationJsGame = null;
    },

    addListener: function (listener) {
        console.log('addListener', listener == null);
        this.listeners.push(listener);
    },

    removeListener: function (listener) {
        console.log('removeListener', listener == null);
        this.listeners = [];
    },

    //加载完成
    loadingDone: function () {
        console.log('native', 'loadingDone');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_LOADING_DONE', JSON.stringify({}));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    //写日志
    writeLog: function (msg) {
        console.log('native', 'writeLog');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_WRITE_LOG', JSON.stringify({
                msg: msg || '',
            }));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    //回到房间
    backToRoom: function () {
        console.log('native', 'backToRoom');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_BACK_TO_ROOM', JSON.stringify({}));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    //游戏结束回调
    gameOverCallback: function () {
        console.log('native', 'gameOverCallback');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_GAME_OVER_CALLBACK', JSON.stringify({}));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    //再来一局
    again: function () {
        console.log('native', 'AGAIN');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_AGAIN', JSON.stringify({}));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    //播放声音
    playVoice: function (src) {
        console.log('native', 'playVoice' + src);

        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_PLAY_VOICE', JSON.stringify({
                src: src || '',
            }));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    stopVoice: function (src)  {
        console.log('native', 'stopVoice' + src);

        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_STOP_VOICE', JSON.stringify({
                src: src || '',
            }));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    // 头像位置回调
    setHeadPosition: function (hPercent, vPercent) {
        console.log('native', 'setHeadPosition');
        if (cc.director.notificationNative) {
            cc.director.notificationNative('COCOS_SET_HEAD_POSITION', JSON.stringify({
                hPercent: hPercent || '',
                vPercent: vPercent || '',
            }));
        } else {
            console.log('cc.director.notificationNative is null');
        }
    },

    quitGame:function(){
        console.log('native','onQuitGame');
        cc.director.end();
        jsb.reflection.callStaticMethod("com/yx/pkgame/cocos/CocosManager", "notificationNative", "(Ljava/lang/String;Ljava/lang/String;)V", "COCOS_QUIT_GAME", "");
    },
});

cc.native = new Native().init();